#pragma once
#include <map>
#include <string>
#include <vector>

using namespace std;
/**
	Żˮ
*/
class CivHydrScheduling
{
public:

	// ͣѹΪ
	enum SchedulingType
	{
		SchedulingFlow,
		SchedulingPressure,
		SchedulingALL
	};

	CivHydrScheduling(SchedulingType schedulingType);

	/**
	* أ inp ļ
	*/
	bool open();

	/**
	*㣬رļ
	*/
	bool close();

	/**
	* ̬ˮò
	*/
	void updatePumpStatus(const map<string, int>& statusMap);

	/**
	* ִһˮ
	*/
	bool  compute();

	/**
	*  ѹ
	*/
	void setPressMonitors(vector<string>& monitors);

	/**
	*  
	*/
	void setFlowMonitor(vector<string>& monitors);

	/**
	*  ȡģֵ
	*/
	void monitorsValue(SchedulingType schedulingType, vector<map<string, double>>& simulMap);


private:
	// : ѹ
	SchedulingType mSchedulingType; 
	
	// ѹ
	vector<string> mPressMonitorMap; 

	// 
	vector<string> mFlowMonitorMap;

	// ѹģֵ
	vector<map<string, double>> mMonitorPressSmulVal; 

	// ģֵ
	vector<map<string, double>> mMonitorFlowSmulVal;
};
