#pragma once
#include <string>
#include <map>
#include <vector>


/**
	ݿ
*/
class  CivConnection
{
public:
	CivConnection();
	virtual ~CivConnection();

	/**
	*@brief ݣйʵ
	*/
	virtual bool connect(const std::string& url) = 0;

	/**
	 *@brief رݣйʵ
	 */
	virtual bool disconnect() = 0;

	/**
	*@brief ִвѯйʵ
	*@param sql ִsql
	*/
	virtual bool execSql(const std::string& sql) = 0;

	/**
	*@brief ȡѯ
	*@param sql 
	*/
	virtual bool queryResult(std::vector<std::map<std::string, std::string>>& result) = 0;

	virtual bool beginTransaction() = 0;

	virtual bool commitTransaction() = 0;
	/**
	*@brief ɾ
	*@param table  
	*@param result Ҫµֶκֵֶӳ
	*@param where 
	*/
	bool update(const std::string& table, const std::map<std::string, std::string>& result, const std::string& where = "1=1");

	/**
	*@brief ɾ
	*@param table  
	*@param where ɾ
	*/
	bool del(const std::string& table, const std::string& where = "1=1");

	/**
	*@brief ݿ
	*@param table  
	*@param result Ҫӵݣֶκֵֶ
	*/
	bool insert(const std::string& table, const std::map<std::string, std::string>& result);

	bool insertBulk(const std::string& table, 
		const std::vector<std::string>& fields,
		const std::vector<std::vector<std::string>>& result);
	/**
	*@brief ִвѯйʵ
	*@param [in] table ѯı
	*@param [in] fields Ҫѯֶ
	*@param [in] result ѯ
	*@param [in] where ѯ,Ĭ
	*/
	bool query(const std::string& table, 
		const std::vector<std::string>&fields, 
		std::vector<std::map <std::string,std::string>>& result , 
		const std::string& where = "1=1");

	// ȡϢ
	std::string getLastError() const;

protected:
	std::string mLastError;
};
