#pragma once
#include<string>
#include<map>

// ˮģʱ
enum QualityType
{
	Age, // ˮ
	Chlorine // 
};

struct ResultItem
{
	std::string code;
	char szNo[64];
	std::string dDate;
	std::string dTime;
	float dQuality;
	float dChlorine;
	std::string dModifyTime;
};

// ڵģֵ
struct NodeResultItem:public ResultItem
{
	float dHead;
	float dPressure;
	float dElevation;
	float dDemand;	
};

// ܶνģֵ
struct LinkResultItem:public ResultItem
{
	char szStatus[32];
	float dFlow;
	float dVelocity;
	float dHeadloss;// λˮ
};

// ˮ
struct TankResultItem :public ResultItem
{	
	float dTankVolume;
	float dTankMaxVolume;
	float dTankLevel;
};

// 
struct ProjResultItem
{
	char szNo[64];
	std::string code; // 룬ܶλ߽ڵݱʶ
	std::string projCode; // 룬ʶһ
	std::string dDateTime;  // 洢ݵĵǰʱ
	std::string dTime; // ģһʱ̵ֵ
};

// 
struct ProjNodeResultItem : public ProjResultItem
{
	float dHead; // ˮͷ
	float dPressure;  // ѹ
	float dProjHead; // ˮͷ
	float dProjPressure;// ѹ
};

// ߽
struct PorjPipeResultItem : public ProjResultItem
{
	float dFlow; // 
	float dVelocity; //
	float dHeadLoss;// λˮͷʧ

	float dPorjHeadLoss;// λˮͷʧ
	float dProjFlow; // 
	float dProjVelocity; // 
};

#define NodeResultItems std::map<std::string,NodeResultItem> 
#define LinkResultItems std::map<std::string,LinkResultItem> 
#define TankResultItems std::map<std::string,TankResultItem>

// ڵ
typedef struct NodeCoord
{
	std::string xCoord; // x
	std::string yCoord; // y
} NodeCoord;

// ܶ
typedef struct PipeCoord
{
	std::string startX; // ʼڵx
	std::string startY; // ʼڵY
	std::string endX;// ֹڵX
	std::string endY;// ֹڵY
}PipeCoord;

// Ϣṹ


#define NodeCoords std::map<std::string,NodeCoord>
#define PipeCoords std::map<std::string,PipeCoord>

