#include "CivHydrTest.h"
#include "CivHydrFuncInter.h"
#include <iostream>


// ˮ
void CivConHydrTest::test(char* uri)
{
    int succ = hdyrSimulation(uri);
    std::cout << "Խ" << succ << std::endl;
}


// ˮʲ
void CivConQuaTest::test(char* uri)
{
    int succ = qualitySimulation(uri);
    std::cout << "Խ" << succ << std::endl;
}

// ׷ٷ
void CivConTrackTest::test(char* uri)
{
    char result[1024 * 512];

    char sn[64];
    strcpy_s(sn, "5fbaaf9e-dfcf-4e97-9fb1-31d03293f654");

    int succ = trackingSimulation(uri, sn, 6, result);

    std::cout << result << std::endl;
    std::cout << "Խ" << succ << std::endl;
}

void CivUpstreamTrackingTest::test(char* uri)
{
    // ׷ٽڵ
    char sn[64];
    strcpy(sn, "5fbaaf9e-dfcf-4e97-9fb1-31d03293f654");

    char result[1024 * 128];

    bool isSucc = upstreamTracking(uri, sn, result);

    std::cout << result << std::endl;
    std::cout << "Խ" << isSucc << std::endl;
}


/**
   ׷
*/
void CivDownStreamTrackingTest::test(char* uri)
{
    // ׷ٽڵ
    char sn[64];
    strcpy(sn, "5fbaaf9e-dfcf-4e97-9fb1-31d03293f654");

    char result[1024 * 512];

    bool isSucc = downstreamTracking(uri, sn, result);

    std::cout << result << std::endl;
    std::cout << "Խ" << isSucc << std::endl;
}


/**
   ˮԴˮΧ
*/
void CivWaterSupplyScopeTest::test(char* uri)
{
    // ׷ٽڵ
    char sn[512];
    strcpy(sn, "ffd0f63d-b8c3-4354-aea5-aedc52cb8e16");

    char result[1024 * 32];

    bool isSucc = waterSupplyScopeAnalysis(uri, sn, result);

    std::cout << result << std::endl;
    std::cout << "Խ" << isSucc << std::endl;
}

void CivProjSimulationTest::test(char* uri)
{
    // ׷ٽڵ
    char projCode[512];
    strcpy(projCode, "ba01c9a8-f113-4131-b566-5f7f1ce25e5c");

    char time[512];
    strcpy(time, "2020-09-24 09:00:00");

    bool isSucc = projSimulation(uri, projCode, time);

    std::cout << "Խ" << isSucc << std::endl;
}
