#pragma once
#include "pandaAlgorithm.h"
#include "genome.h"

#include <memory>
#include <string>
#include <vector>
#include <map>
#include <time.h>
#include<stdlib.h>

using namespace std;

#define MAX_RANDOM 2147483647.0

class  OptScheduling;
/**
   Ŵ㷨
*/
class PANDAALGORITHM_API  GenAlg
{
public:
    // 
    enum GenType
    {
        RealValueCoding,
        BinaryCoding
    };

    //캯  
    GenAlg(OptScheduling* optScheduling, GenType genType);

    //ʼ  
    void reset();

    //ʼ  
    void init(int popsize, double MutRate, double CrossRate, int GenLenght, double LeftPoint, double RightPoint);

    // mTotalFitness, mBestFitness, mWorstFitness, mAverageFitnessȱ  
    void calculateBestWorstAvTot();

    // ̶ѡ  
    Genome chromoRoulette();


    // 캯ʵֵ룩  
    void mutate(vector<double>& chromo);

    // 캯Ʊ룩  
    void mutate(vector<char>& chromo);

    //⺯һ  
    void epoch(vector<Genome>& vecNewPop);

    // ȡӦȵĻ
    Genome bestFitness();

    // ȡƽӦ
    double averageFitness();

    // л
    void corssver();
  
    // ѡ㣬ǰȺӦȽϸߵĸ尴ĳֹģŴһȺ
    void select();

    // Ӧ
    void fitnessfunction();

    /**
    * @brief , ˮÿ״̬ɶ״̬0ʾܣ1ʾ
    * @param 
    */
    void encoding(map<string, int>& phenotype, vector<char>& chromo);

    /**
    * @brief , ״̬ˮöӦ״̬
    * @param 
    */
    void decoding(vector<char>& chromo,map<string,int>& phenotype);

private:
    // [a,b)֮ĸ
    double random(int a=0, int b= RAND_MAX);

    // Ⱦɫ彻
    void crossover(vector<char>& chromo1, vector<char>& chromo2);

private:
    // ÿһȾɫ  
    vector <Genome>    vecPop;

    // 
    GenType mGenType;

    // Ⱥ  
    int mPopSize;

    // ÿһȾɫĻĿ  
    int mChromoLength;

    // иӦӦֵܺ  
    double mTotalFitness;

    //и嵱ӦĸӦ  
    double mBestFitness;

    // иӦֵƽֵ  
    double mAverageFitness;

    // и嵱ӦĸӦ  
    double mWorstFitness;

    // Ӧĸm_vecPop  
    Genome mFittestGenome;

    // ͻĸ,һ0.050.3֮  
    double mMutationRate;

    // 򽻲ĸһΪ0.7  
    double mCrossoverRate;

    // ļ  
    int mGeneration;

    // 첽  
    double mMaxPerturbation;

    // ߽
    double mLeftPoint;

    // ұ߽
    double mRightPoint;

    // ŻȺ
    std::unique_ptr<OptScheduling> mOptScheduling;
};
