#pragma once
#include <string>
#include "CivInpBuilder.h"

/**
  ݿתinpļת
*/
class CivInpConvertor
{
public:
	explicit CivInpConvertor(const std::string& uri);
	~CivInpConvertor();

	bool maintainTopo();

	/**
	 *@brief תɷģinpļ
	 *@param projCode 
	 *@param startTime ģʱ
	 */
	std::string convertPorjInp(const std::string& projCode, const std::string& startTime);

	/**
	 *@brief ģʱֵתinpļ
	 *@param [std::string] simulTime ģʱ
	 */
	std::string convertNotPorjInp(const std::string& simulTime);

	/**
	 *@brief תɷͨinp
	 */
	std::string convertBaseInp();

	/**
	 *@brief ׷ģinpļ
	 *@param sn ׷ٵĽڵ
	 *@param hours ׷Сʱ
	 */
	std::string convertTrackInp(const std::string& sn, const std::string& hours);

	std::string convertAnalysisInp();

	/**
	 * ȷ
	 */
	std::string convertResidualInp();

private:
	std::string mUri;
};