#pragma once
#include<string>
#include<vector>
#include "CivSimuResStruct.h"
#include "pandaDbManager.h"
#include "CivSimulResHelperAbs.h"

class CivConnection;

/**
*@brief ģ
*/
class PANDADBMANAGER_API CIvProjSimulResHelper: public CivSimulResHelperAbs
{
public:
	explicit CIvProjSimulResHelper(const std::string& uri);
	~CIvProjSimulResHelper();

	/**
	*@brief 淽ģĽڵ
	*@param [in] nodeItem ģĽڵֵ
	*/
	virtual void saveNodeToDb(const std::vector<ProjNodeResultItem>& nodeItem);

	/**
	*@brief 淽ģĹܶ
	*@param [in] nodeItem ģĽڵֵ
	*/
	virtual void savePipeToDb(const std::vector<PorjPipeResultItem>& pipeItem);

	/**
    *@brief ʱֶɾ
    *@param [in] time ʱ
	*@param [in] projCode 
   */
	void deleteByTimeAndPorjcode(const std::string& time, const std::string& projCode);

private:
	std::string mPreNodeSQL;
	std::string mPrePipeSQL;
};
